#ifndef SOLID__H
#define SOLID__H

class Solid
{
private:
    int die[5];     // The 5 dice
    int group[5];   // valid values are 0 (denoting the reject), 1, and 2
                    // -1 is used to denote "not set"
                    
    int freebie;    // True if the roll is a freebie
                    // i.e. 3 different numbers have already been used
                    // as the reject, and this roll contains none of them

    int hits[13];   // Note elements 0 and 1 aren't used

    int rejectCount[7];   // Note that element 0 isn't used
                          // rejectCount[n] is how many times the number n
                          // has been used as the reject

    int numRejects;

public:
    // default ctor not needed

    // initialized ctor
    Solid( int seed = 1 );

    // copy ctor not needed
    
    // conversion ctor not needed

    // assignment op not needed
    
    // dtor not needed

    // ------------
    //  inspectors    
    // ------------

    int Die( int )      const;
    int Group( int )    const;

    int Score()         const;

    int Hits( int )     const;    

    int NumRejects()           const;
    int RejectCounts( int )    const;

    int Over()          const;
    
    // ----------
    //  mutators
    // ----------

    int Roll();

    int SetGroup( int die, int group );

    int CommitTurn();
};


#endif

